<script>
import { GlLink, GlTableLite } from '@gitlab/ui';
import { getIDfromGraphqlId, getDuoWorkflowStatusDisplay } from '../utils';
import { formatTimeAgo } from '../utils/time_utils';
import { WORKFLOW_SHOW_APP } from '../router/constants';

export default {
  components: {
    GlLink,
    GlTableLite,
  },
  props: {
    workflows: {
      type: Array,
      required: true,
    },
  },
  methods: {
    formatDate(date) {
      return formatTimeAgo(date);
    },
    showPageLink(id) {
      return {
        name: WORKFLOW_SHOW_APP,
        params: { workflowId: this.toHumanId(id) },
      };
    },
    toHumanId(graphqlId) {
      return getIDfromGraphqlId(graphqlId);
    },
    toHumanStatus(status) {
      const formattedStatus = status.replace(/\s/g, '_');
      return getDuoWorkflowStatusDisplay(formattedStatus.toUpperCase());
    },
  },
  fields: [
    { key: 'goal', label: 'Description' },
    { key: 'humanStatus', label: 'Status' },
    { key: 'updatedAt', label: 'Updated' },
    { key: 'id', label: 'ID' },
  ],
};
</script>
<template>
  <div>
    <gl-table-lite :items="workflows" :fields="$options.fields">
      <template #cell(goal)="{ item }">
        <gl-link
          :to="showPageLink(item.id)"
          data-testid="workflow-goal-link"
          :data-test="JSON.stringify(showPageLink(item.id))"
          >{{ item.goal }}</gl-link
        >
      </template>
      <template #cell(id)="{ item }">
        <span data-testid="workflow-id" class="gl-text-secondary">{{ toHumanId(item.id) }}</span>
      </template>
      <template #cell(humanStatus)="{ item }">
        <span class="gl-text-secondary">
          {{ toHumanStatus(item.humanStatus) }}
        </span>
      </template>
      <template #cell(updatedAt)="{ item }">
        <span class="gl-text-secondary">
          {{ formatDate(item.updatedAt) }}
        </span>
      </template>
    </gl-table-lite>
  </div>
</template>
